
/* Chrysalide - Outil d'analyse de fichiers binaires
 * instruction-int.h - prototypes pour la définition générique interne des instructions Dalvik
 *
 * Copyright (C) 2011 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ARCH_DALVIK_INSTRUCTION_INT_H
#define _ARCH_DALVIK_INSTRUCTION_INT_H


#include "instruction-def.h"
#include "../instruction-int.h"



/* Définition générique d'une instruction d'architecture Dalvik (instance) */
struct _GDalvikInstruction
{
    GArchInstruction parent;                /* A laisser en premier        */

    const char *keyword;                    /* Nom clef de l'instruction   */

    DalvikOpcodes type;                     /* Position dans la liste      */
    DalvikPseudoOpcodes ptype;              /* Position dans la liste #2   */

};

/* Définition générique d'une instruction d'architecture Dalvik (classe) */
struct _GDalvikInstructionClass
{
    GArchInstructionClass parent;           /* A laisser en premier        */

};



#endif  /* _ARCH_DALVIK_INSTRUCTION_INT_H */
