
/* Chrysalide - Outil d'analyse de fichiers binaires
 * tcp.h - prototypes pour la gestion des connexions TCP aux serveurs JDWP.
 *
 * Copyright (C) 2010 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DEBUG_JDWP_TCP_H
#define _DEBUG_JDWP_TCP_H


#include "../stream.h"



#define G_TYPE_JDWP_TCP_CLIENT               g_jdwp_tcp_client_get_type()
#define G_JDWP_TCP_CLIENT(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_jdwp_tcp_client_get_type(), GJdwpTcpClient))
#define G_IS_JDWP_TCP_CLIENT(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_jdwp_tcp_client_get_type()))
#define G_JDWP_TCP_CLIENT_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_JDWP_TCP_CLIENT, GJdwpTcpClientClass))
#define G_IS_JDWP_TCP_CLIENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_JDWP_TCP_CLIENT))
#define G_JDWP_TCP_CLIENT_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_JDWP_TCP_CLIENT, GJdwpTcpClientClass))


/* Flux de communication TCP avec un serveur JDWP (instance) */
typedef struct _GJdwpTcpClient GJdwpTcpClient;

/* Flux de communication TCP avec un serveur JDWP (classe) */
typedef struct _GJdwpTcpClientClass GJdwpTcpClientClass;



/* Indique le type défini pour un flux de communication TCP avec un serveur JDWP. */
GType g_jdwp_tcp_client_get_type(void);

/* Crée une nouvelle connexion TCP à un serveur JDWP. */
GDebugStream *g_jdwp_tcp_client_new(const char *, const char *);



#endif  /* _DEBUG_JDWP_TCP_H */
