
/* Chrysalide - Outil d'analyse de fichiers binaires
 * array.h - prototypes pour les manipulations de tableaux génériques
 *
 * Copyright (C) 2010 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_EXPR_ARRAY_H
#define _DECOMP_EXPR_ARRAY_H


#include <glib-object.h>


#include "../expression.h"
#include "../instruction.h"



#define G_TYPE_ARRAY_ACCESS               g_array_access_get_type()
#define G_ARRAY_ACCESS(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_array_access_get_type(), GArrayAccess))
#define G_IS_ARRAY_ACCESS(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_array_access_get_type()))
#define G_ARRAY_ACCESS_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_ARRAY_ACCESS, GArrayAccessClass))
#define G_IS_ARRAY_ACCESS_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_ARRAY_ACCESS))
#define G_ARRAY_ACCESS_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_ARRAY_ACCESS, GArrayAccessClass))



/* Définition d'un accès à une cellule de tableau (instance) */
typedef struct _GArrayAccess GArrayAccess;

/* Définition d'un accès à une cellule de tableau (classe) */
typedef struct _GArrayAccessClass GArrayAccessClass;



/* Indique le type défini pour un accès à une cellule de tableau. */
GType g_array_access_get_type(void);

/* Construit un accès à une cellule de tableau comme expression. */
GDecInstruction *g_array_access_new(GDecExpression *, GDecExpression *);



#endif  /* _DECOMP_EXPR_ARRAY_H */
