
/* Chrysalide - Outil d'analyse de fichiers binaires
 * immediate.h - prototypes pour le raccord avec les opérandes de valeur immédiate
 *
 * Copyright (C) 2010 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_EXPR_IMMEDIATE_H
#define _DECOMP_EXPR_IMMEDIATE_H


#include <glib-object.h>


#include "../instruction.h"
#include "../../arch/immediate.h"



#define G_TYPE_IMM_EXPRESSION               g_imm_expression_get_type()
#define G_IMM_EXPRESSION(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_imm_expression_get_type(), GImmExpression))
#define G_IS_IMM_EXPRESSION(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_imm_expression_get_type()))
#define G_IMM_EXPRESSION_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_IMM_EXPRESSION, GImmExpressionClass))
#define G_IS_IMM_EXPRESSION_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_IMM_EXPRESSION))
#define G_IMM_EXPRESSION_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_IMM_EXPRESSION, GImmExpressionClass))



/* Définition d'une expression de valeur immédiate (instance) */
typedef struct _GImmExpression GImmExpression;

/* Définition d'une expression de valeur immédiate (classe) */
typedef struct _GImmExpressionClass GImmExpressionClass;



/* Indique le type défini pour une expression de valeur immédiate. */
GType g_imm_expression_get_type(void);

/*Construit une expression à partir d'une valeur immédiate. */
GDecInstruction *g_imm_expression_new(GImmOperand *);



#endif  /* _DECOMP_EXPR_IMMEDIATE_H */
