
/* Chrysalide - Outil d'analyse de fichiers binaires
 * expression-int.h - prototypes pour la définition interne des expressions décompilées
 *
 * Copyright (C) 2010-2013 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_EXPRESSION_INT_H
#define _DECOMP_EXPRESSION_INT_H


#include "expression.h"
#include "instruction-int.h"



/* Réalise une négation sur une expression décompilée. */
typedef bool (* dec_expr_negate_fc) (GDecExpression *);


/* Définition d'une expression décompilée (instance) */
struct _GDecExpression
{
    GDecInstruction parent;                 /* A laisser en premier        */

    dec_expr_negate_fc negate;              /* Négation de l'expression    */
    dec_instr_print_fc original_print;      /* Eventuelle version négative */

};


/* Définition d'une expression décompilée (classe) */
struct _GDecExpressionClass
{
    GDecInstructionClass parent;            /* A laisser en premier        */

};



#endif  /* _DECOMP_EXPRESSION_INT_H */
